mod Ex08 logic: 'cl'

incl Mtex

incl Mtexrc

incl Mtexxpr

incl Maux

incl Mxprf

incl Mxu

incl Mxprt

rem 
  \para \bf  8. CVICENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 16.11.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane p.r. indexom. 
  Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor \it  mxprf.cl  \end obsahuje aritmetizaciu p.r. funkcnych 
         symbolov. 
   \item \para Subor \it  mxu.cl  \end obsahuje interpreter p.r. funkcnych 
         symbolov. 
   \item \para Subor \it  mxprt.cl  \end obsahuje aritmetizaciu p.r. termov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 4 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 2 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/1-INF-450-lpi/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 21.11.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end See the module \it  Mclsyntax  \end in the file 
  \it  mclsyntax.cl  \end. 

rem 
  \para \bf  [CL] Remark.  \end Catalan pairing function - see the module 
  \ft Maux \end. 

rem 
  \para \bf  [CL] Remark.  \end Clausal language is allowed. 

rem 
  \para \bf  Chapter. Recursive Functions.  \end 

rem 
  \para \bf  Section. Beyond Primitive Recursion.  \end 

rem 
  \para \bf  Subsection. Universal Function for Primitive Recursive Functions is 
  not Primitive Recursive.  \end 

rem 
  \para \bf  Arithmetization of p.r. function symbols.  \end See also the module 
  \ft Mxprf \end. 

rem 
  \para \bf  Primitive recursive indices.  \end See also the predicate 
  \ft Prf(e) \end holding of well-formed p.r. indices in the module 
  \ft Mxprf \end. 

rem 
  \para \bf  Effective operations on p.r. indices.  \end 

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun Xc1 'Tex_f1_xpr_xc1' \end Define the function \ft Xc1(m) \end 
  such that 
  \eq* 
    U(Xc1(m),x) = m
  \end

fun Xc1 'Tex_f1_xpr_xc1'
  Xc1(m) = Foo

thm Spec_xc1
  U(Xc1(m),x) = m

rem 
  \para \bf  Exercise.  \end \header* fun/2 Xc2 'Tex_f2_xpr_xc2' \end Define the 
  binary primitive recursive function \ft Xc2(n,m) \end satisfying 
  \eq* 
    U(Xc2(n,m),x1,Texm_f0_dotsc,Texm_f2_sub(x,n)) = m
  \end

fun/2 Xc2 'Tex_f2_xpr_xc2'
  Xc2(n,m) = Foo

thm Spec_xc2_1
  U(Xc2(1,m),x1) = m

thm Spec_xc2_2
  U(Xc2(2,m),x1,x2) = m

thm Spec_xc2_3
  U(Xc2(3,m),x1,x2,x3) = m

rem 
  \para \bf  Primitive recursive terms.  \end 

rem 
  \para \bf  Arithmetization of p.r. terms.  \end See also the module 
  \ft Mxprt \end. 

rem 
  \para \bf  Denotation of p.r. terms.  \end 

fun/3 Den 'Tex_f3_xpr_den'
  Den(n,t,v) = Foo

rem 
  \para \bf  Explicit definitions.  \end \it  [Uloha (1 bod)]  \end 
  \header* fun/2 Xedf 'Tex_f2_xpr_xedf' \end \header* fun/3 F 'Tex_f3_f' \end 
  Define the binary function \ft Xedf(n,t) \end such that 
  \items 
   \item \para for every \ft n >= 1 \end, if the number \ft t \end is the code 
         of a p.r. term 
         \ft Texm_f3_subst_dotsc(Tex0_tau,x1,Texm_f2_sub(x,n)) \end with all its 
         free variables indicated then the application \ft Xedf(n,t) \end yields 
         a p.r. index of the n-ary p.r. function \ft Texm_f0_f \end explicitly 
         defined by 
         \eq* 
           F(x1,Tex0_dotsc,Texm_f2_sub(x,n)) = 
           Texm_f3_subst_dotsc(Tex0_tau,x1,Texm_f2_sub(x,n))
         \end
         \para or equivalently, we wish to have 
         \eq* 
           U(Xedf(n,t),v) = Den(n,t,v)
         \end
         \para for every \ft n \end-tuple \ft v \end. 
  \end
  \para \it  Remark.  \end You will need the unary function \ft Ar(f) \end 
  yielding the arity of the p.r. function symbol \ft f \end. The function is 
  defined in the module \it  Mprf  \end. 
  \para \it  Remark.  \end Clausal language allowed. 

fun/2 Xedf 'Tex_f2_xpr_xedf'
  Xedf(n,t) = Foo

rem 
  \para \bf  Exercise.  \end Find p.r. indices of \ft x+y \end, \ft x*y \end and 
  \ft Texm_f2_n_exp(x,y) \end with the help of \ft Xedf(n,t) \end. 

fun/0 Xplus 'Tex_f0_xpr_xplus'
  Xplus = Foo

thm Spec_xplus
  U(Xplus,x,y) = x+y

fun/0 Xtimes 'Tex_f0_xpr_xtimes'
  Xtimes = Foo

thm Spec_xtimes
  U(Xtimes,x,y) = x*y

fun/0 Xexp 'Tex_f0_xpr_xexp'
  Xexp = Foo

thm Spec_xexp
  U(Xexp,x,y) = Exp(x,y)

rem 
  \para \bf  Iteration.  \end \header* fun Xiter 'Tex_f1_xpr_xiter' \end Define 
  a function \ft Xiter(e) \end such that 
  \eq* 
    U(Xiter(e),0,x) = x
  \end
  \eq* 
    U(Xiter(e),n+1,x) = U(e,U(Xiter(e),n,x))
  \end
  \para In other words, if \ft e \end is a p.r. index of a unary function then 
  \ft Xiter(e) \end is a p.r. index of its iteration. 

fun Xiter 'Tex_f1_xpr_xiter'
  Xiter(e) = Foo

thm Spec_xiter_zero
  U(Xiter(e),0,x) = x

thm Spec_xiter_succ
  U(Xiter(e),n+1,x) = U(e,U(Xiter(e),n,x))

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end Find a p.r. index of 
  \ft x+y \end which corresponds to the p.r. derivation of addition as an 
  iteration of the successor function. 

fun/0 Xplus2 'Tex_f0_xpr_xplus'
  Xplus2 = Foo

thm Spec_xplus2
  U(Xplus2,x,y) = x+y

rem 
  \para \bf  Parameterless primitive recursion.  \end 
  \header* fun/2 Xrec0 'Tex_f2_xpr_xrec0' \end \header* fun F 'Tex_f1_f' \end 
  \header* fun/2 H 'Tex_f2_h' \end \header* fun/0 M 'Tex_f0_m' \end Define a 
  function \ft Xrec0(m,e) \end satisfying 
  \eq* 
    U(Xrec0(m,e),0) = m
  \end
  \eq* 
    U(Xrec0(m,e),x+1) = U(e,x,U(Xrec0(m,e),x))
  \end
  \para In other words, if \ft M \end is a constant and \ft e \end is a p.r. 
  index of a binary function \ft H(x,a) \end then \ft Xrec0(m,e) \end is a p.r. 
  index of the unary function \ft F(x) \end defined by following parameterless 
  primitive recursion: 
  \def 
    fun F 'Tex_f1_f'
    F(0) = M
    F(x+1) = H(x,F(x))
  \end

fun/2 Xrec0 'Tex_f2_xpr_xrec0'
  Xrec0(m,e) = Foo

thm Spec_xrec0_zero
  U(Xrec0(m,e),0) = m

thm Spec_xrec0_succ
  U(Xrec0(m,e),x+1) = U(e,x,U(Xrec0(m,e),x))

rem 
  \para \bf  Exercise.  \end Find a p.r. index of \ft x-1 \end which corresponds 
  to the derivation of the predecessor function by parameterless recursion. 

fun/0 Xpred 'Tex_f0_xpr_xpred'
  Xpred = Foo

thm Spec_xpred
  U(Xpred,x) = x-1

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end Find a p.r. index of 
  \ft x-y \end which corresponds to the p.r. derivation of modified subtraction 
  as an iteration of the predecessor function. 

fun/0 Xminus 'Tex_f0_xpr_xminus'
  Xminus = Foo

thm Spec_xminus
  U(Xminus,x,y) = x-y

rem 
  \para \bf  Parametric function (Kleene).  \end 
  \header* fun/2 Xparam 'Tex_f2_xpr_xparam' \end Define the function 
  \ft Xparam(e,x) \end such that 
  \eq* 
    U(Xparam(e,x),y) = U(e,x,y)
  \end

fun/2 Xparam 'Tex_f2_xpr_xparam'
  Xparam(e,x) = Foo

thm Spec_xparam
  U(Xparam(e,x),y) = U(e,x,y)

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun/3 Xsmn_2_3 'Tex_f3_xpr_xsmn_2_3' \end Prove the Kleene's s-m-n 
  theorem for the case \ft m = 2 \end and \ft n = 3 \end by providing a ternary 
  primitive recursive function \ft Xsmn_2_3(e,x1,x2) \end satisfying 
  \eq* 
    U(Xsmn_2_3(e,x1,x2),y1,y2,y3) = U(e,x1,x2,y1,y2,y3)
  \end

fun/3 Xsmn_2_3 'Tex_f3_xpr_xsmn_2_3'
  Xsmn_2_3(e,x1,x2) = Foo

thm Spec_xsmn_2_3
  U(Xsmn_2_3(e,x1,x2),y1,y2,y3) = U(e,x1,x2,y1,y2,y3)

rem 
  \para \bf  Exercise.  \end \header* fun Xdiag 'Tex_f1_xpr_xdiag' \end Define a 
  primitive recursive function \ft Xdiag(e) \end satisfying 
  \eq* 
    U(Xdiag(e),x) = U(e,x,x)
  \end
  \para In other words, if \ft e \end is a p.r. index of a binary function then 
  \ft Xdiag(e) \end is a p.r. index of its diagonalization. 

fun Xdiag 'Tex_f1_xpr_xdiag'
  Xdiag(e) = Foo

thm Spec_xdiag
  U(Xdiag(e),x) = U(e,x,x)

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun Xcantor 'Tex_f0_xpr_xcantor' \end 
  \header* fun Xu2 'Tex_f0_xpr_xu2' \end Show that the binary function 
  \ft U(e,x) \end is not primitive recursive, that is 
  \eq* 
    ~\e e\a x\a y U(e,x,y) = U(x,y)
  \end
  \para or equivalently 
  \eq* 
    \a e\e x\e y U(e,x,y) != U(x,y)
  \end
  \para by providing a primitive recursive function \ft Xcantor(e) \end 
  satisfying 
  \eq* 
    U(e,Xcantor(e),Xcantor(e)) != U(Xcantor(e),Xcantor(e))
  \end

fun Xcantor 'Tex_f0_xpr_xcantor'
  Xcantor(e) = Foo

thm Spec_xcantor
  U(e,Xcantor(e),Xcantor(e)) != U(Xcantor(e),Xcantor(e))

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

rem 
  \para Formats for testing binary functions and predicates. Examples of usage: 
  \items 
   \item \para define \ft Test_fun(x) = H(x)+T(x) \end and run query \it  
         Itf(10)=x:Lf2  \end 
   \item \para define \ft Test_pred(x) <-> H(x) <= T(x) \end and run query \it  
         Itp(10)=x:Lp2  \end 
  \end

loc pred Nn 
  Nn(0)
  Nn(x1,x2) <- N(x1) & N(x2)

loc pred Nnn 
  Nnn(x,y) <- Nn(x) & N(y)

loc pred Lf2 
  Lf2(0)
  Lf2(v,w) <- Nnn(v) & Lf2(w)

loc pred Lp2 
  Lp2(0)
  Lp2(v,w) <- Nn(v) & Lp2(w)

